# std::vector::resize

From cppreference.com
< cpp‎ | container‎ | vector

void resize( size_type count, T value = T() ); |  | (until C++11)
void resize( size_type count ); | (1) | (since C++11)
void resize( size_type count, const value_type& value ); | (2) | (since C++11)

Resizes the container to contain `count` elements.

If the current size is greater than `count`, the container is reduced to its first `count` elements.

If the current size is less than `count`, additional elements are appended and initialized with copies of `value`. | (until C++11)
If the current size is less than `count`, 1) additional default-inserted elements are appended 2) additional copies of `value` are appended | (since C++11)

### Parameters

count | - | new size of the container
value | - | the value to initialize the new elements with
Type requirements
- `T` must meet the requirements of `MoveInsertable` and `DefaultInsertable` in order to use overload (1).
- `T` must meet the requirements of `CopyInsertable` in order to use overload (2).

### Return value

(none)

### Complexity

Linear in the difference between the current size and `count`.

### Exceptions

If an exception is thrown, this function has no effect (strong exception guarantee).

In overload (1), if `T`'s move constructor is not noexcept and T is not `CopyInsertable` into `*this`, vector will use the throwing move constructor. If it throws, the guarantee is waived and the effects are unspecified. | (since C++11)

### Notes

If value-initialization in overload (1) is undesirable, for example, if the elements are of non-class type and zeroing out is not needed, it can be avoided by providing a custom Allocator::construct.

Vector capacity is never reduced when resizing to smaller size because that would invalidate all iterators, rather than only the ones that would be invalidated by the equivalent sequence of pop_back() calls.

### Example

Run this code

    #include <iostream>
    #include <vector>
    int main()
    {
        std::vector<int> c = {1, 2, 3};
        std::cout << "The vector holds: ";
        for(auto& el: c) std::cout << el << ' ';
        std::cout << '\n';
        c.resize(5);
        std::cout << "After resize up 5: ";
        for(auto& el: c) std::cout << el << ' ';
        std::cout << '\n';
        c.resize(2);
        std::cout << "After resize down to 2: ";
        for(auto& el: c) std::cout << el << ' ';
        std::cout << '\n';
    }

Output:

    The vector holds: 1 2 3
    After resize up 5: 1 2 3 0 0
    After resize down to 2: 1 2

### See also

size | returns the number of elements (public member function)
insert | inserts elements (public member function)
erase | erases elements (public member function)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/container/vector/resize&oldid=80638"